
#ifndef OUR_SPI_H__
#define OUR_SPI_H__

#include <stdint.h>
#include "nrf_drv_spi.h"
#include "app_util_platform.h"
#include "nrf_gpio.h"
#include "nrf_delay.h"
#include "boards.h"
#include "app_error.h"
#include <string.h>
#include "nrf_log.h"
#include "nrf_log_ctrl.h"
#include "nrf_log_default_backends.h"

#define SPI_INSTANCE  0 /**< SPI instance index. */
static const nrf_drv_spi_t spi = NRF_DRV_SPI_INSTANCE(SPI_INSTANCE);  /**< SPI instance. */
static volatile bool spi_xfer_done;  /**< Flag used to indicate that SPI instance completed the transfer. */

#define W25X_WriteEnable 0x06
#define W25X_JedecDeviceID 0X9F
#define W25X_ReadStatusReg 0x05
#define W25X_SectorErase 0xD8
#define W25X_PageProgram 0x02 
#define W25X_ReadData 0x03 
#define W25X_ChipErase 0xC7
#define FLASH_ID 0XC22014  //件ID
#define Dummy_Byte 0XFF
#define WIP_Flag  0x01

#define SPI_BUFSIZE 8 //SPI缓大


void W25Q80_write_reg(int data);
uint8_t W25Q80_read_reg(int reg);
uint32_t W25Q80_ReadID(void);
void W25Q80_WriteEnable(void);
void W25Q80_WaitForWriteEnd(void);
void W25Q80_FLASH_SectorErase(uint32_t SectorAddr);
void W25Q80_FLASH_PageWrite(uint8_t* pBuffer, uint32_t WriteAddr, uint16_t NumByteToWrite);
void W25Q80_Flash_BufferRead(uint8_t* pBuffer, uint32_t ReadAddr, uint16_t NumByteToRead);
void W25Q80_Chip_Erase(void);
void W25Q80_init(void);

#endif  /* _ OUR_SPI_H__ */