#include <stdint.h>
#include "our_twi.h"
#include "nrf_drv_twi.h"
#include "nrf_log.h"
#include "nrf_log_ctrl.h"
#include "nrf_log_default_backends.h"
uint8_t date_time[6];//y m d  h m s

void DS3231_set_time(uint8_t hour, uint8_t min, uint8_t sec)
{
	if (sec >= 0 && sec <= 59 && min >= 0 && min <= 59 && hour > 0 && hour <= 24)
	{
		uint8_t reg[4] = { REG_SEC, sec, min, hour };
		m_xfer_done = false;
		nrf_drv_twi_tx(&m_twi, DS3231_ADDR, reg, 4, false);
		while (m_xfer_done == false);
	}
}
void DS3231_set_data(int year, uint8_t month, uint8_t date)
{
	uint8_t year2;

	// 	if (year >= 2000 && year <= 2100)
	// 	{
	// 		year2 = (uint8_t)(year - 2000);
	// 		reg[3] = year2;
	// 		if (date > 0 && date <= 31 && month > 0 && month <= 12 && year > 0 && year2 <= 99)
	// 		{
	// 			reg[0] = REG_DATE;
	// 			reg[1] = date;
	// 			reg[2] = month;
	// 			m_xfer_done = false;
	// 			nrf_drv_twi_tx(&m_twi, DS3231_ADDR, reg, sizeof(reg), false);
	// 			while (m_xfer_done == false);
	// 		}
	// 	}
	if (date > 0 && date <= 31 && month > 0 && month <= 12 && year >= 0)
	{
		uint8_t reg[4] = { REG_DATE, date, month, year };
		m_xfer_done = false;
		nrf_drv_twi_tx(&m_twi, DS3231_ADDR, reg, 4, false);
		while (m_xfer_done == false);
	}
}
// uint8_t hex2bcd(uint8_t x)
// {
// 	uint8_t y;
// 	y = (x / 10) << 4;
// 	y = y | (x % 10);
// 	return (y);
// }
// uint8_t hex2bcd(uint8_t data)
// {
// 	uint8_t tmp = (data >> 4) * 10 + (data & 0x0f);
// 	return tmp;
// }
void DS3231_read()
{
	uint8_t reg;
	uint8_t temp[7];
	reg = REG_SEC;
	m_xfer_done = false;
	nrf_drv_twi_tx(&m_twi, DS3231_ADDR, &reg, sizeof(reg), true);
	while (m_xfer_done == false);
	m_xfer_done = false;
	nrf_drv_twi_rx(&m_twi, DS3231_ADDR, temp, sizeof(temp));
	while (m_xfer_done == false);
	for (int i = 6; i >= 0; i--)
	{
		NRF_LOG_INFO(" %d ", temp[i]);
	}
	date_time[0] = temp[6];
	date_time[1] = temp[5];
	date_time[2] = temp[4];
	date_time[3] = temp[2];
	date_time[4] = temp[1];
	date_time[5] = temp[0];
	//	NRF_LOG_INFO(" --\n ");
}

void twi_handler(nrf_drv_twi_evt_t const* p_event, void* p_context)
{
	switch (p_event->type)
	{
	case NRF_DRV_TWI_EVT_DONE:
		if (p_event->xfer_desc.type == NRF_DRV_TWI_XFER_RX)
		{
			//              NRF_LOG_INFO((0, "Got data from sensor!\n");
			//              ret_code_t err_code;
			//              unsigned short ST=id[0], SRH=id[3];
			//              ST<<=8;
			//              ST|=id[1];
			//              SRH <<=8;
			//              SRH|=id[4];
			//              temperature=ST;
			//              temperature*=175;
			//              temperature/=0xffff;
			//              temperature=-45+temperature;
			//              relative_humidity=SRH;
			//              relative_humidity*=100;      
			//              relative_humidity/=0xFFFF;
			//              NRF_LOG_INFO((0, "Temperature: %d\n", (int)(temperature*100));
			//              NRF_LOG_INFO((0, "Relative humidity: %d\n", (int)(relative_humidity*100));
			//              data_available = true;
		}
		m_xfer_done = true;
		break;
	default:
		break;
	}
}

void twi_init(void)
{
	ret_code_t err_code;

	const nrf_drv_twi_config_t twi_sht3x_config = {
	   .scl = 18,//13,
	   .sda = 19,//14,
	   .frequency = NRF_DRV_TWI_FREQ_250K,
	   .interrupt_priority = APP_IRQ_PRIORITY_HIGH,
	   .clear_bus_init = false
	};

	err_code = nrf_drv_twi_init(&m_twi, &twi_sht3x_config, twi_handler, NULL);
	APP_ERROR_CHECK(err_code);

	nrf_drv_twi_enable(&m_twi);
}


static void read_sensor_data()
{
	ret_code_t err_code;
	uint8_t id[6];
	m_xfer_done = false;
	uint8_t cmd[2];
	cmd[0] = (SHT31_MEAS_MEDREP_STRETCH >> 8) & 0xff;
	cmd[1] = SHT31_MEAS_MEDREP_STRETCH & 0xff;
	err_code = nrf_drv_twi_tx(&m_twi, SHT3X_ADDR, cmd, sizeof(cmd), false);
	APP_ERROR_CHECK(err_code);
	while (m_xfer_done == false) {

	}
	m_xfer_done = false;
	err_code = nrf_drv_twi_rx(&m_twi, SHT3X_ADDR, id, sizeof(id));
	APP_ERROR_CHECK(err_code);
}