#ifndef OUR_TWI_H__
#define OUR_TWI_H__

#include "nrf_drv_twi.h"


/* Common addresses definition for temperature sensor. */
#define SHT3X_ADDR          (0x44)
#define SHT31_MEAS_MEDREP_STRETCH  0x2C0D // Seems to work on PI but shouldn't
#define DS3231_ADDR     0x68
#define REG_SEC		0x00
#define REG_MIN		0x01
#define REG_HOUR	0x02
#define REG_DOW		0x03
#define REG_DATE	0x04
#define REG_MON		0x05
#define REG_YEAR	0x06
#define REG_CON		0x0e
#define REG_STATUS	0x0f
#define REG_AGING	0x10
#define REG_TEMPM	0x11
#define REG_TEMPL	0x12

/* TWI instance. */
#define TWI_INSTANCE_ID     1
static const nrf_drv_twi_t m_twi = NRF_DRV_TWI_INSTANCE(TWI_INSTANCE_ID);
static volatile bool m_xfer_done = false;

void DS3231_set_time(uint8_t hour, uint8_t min, uint8_t sec);
void DS3231_set_data(int year , uint8_t month , uint8_t date);
void DS3231_read();
void twi_init(void);
static void read_sensor_data();
extern uint8_t date_time[6];

#endif  /* _ OUR_TWI_H__ */
